<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task20.100</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<style>
    body {
        margin: 20px;
    }
    input {
        width: 100%;
    }
</style> 
</head>
<body>
    <div class="row">
        <div class="col-sm-12">
            <h4 class="text-center">Registration form</h4>
        </div>
    </div>
    <div class="form-group">
        <div class="row form-group">
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>First Name <span class = "text-danger">(*)</span></label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-fname">
                    </div>
                </div>
            </div>
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Passport <span class = "text-danger">(*)</span></label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-passport">
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group"> 
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Last Name <span class = "text-danger">(*)</span></label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-lname">
                    </div>
                </div>
            </div>
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Email</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-email">
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Birth Day <span class = "text-danger">(*)</span></label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-bday">
                    </div>
                </div>
            </div>
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Country <span class = "text-danger">(*)</span></label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-country">
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Gender <span class = "text-danger">(*)</span></label>
                    </div>
                    <div class="col-sm-8">
                        <div class="row">
                            <div class="col-sm-2">
                                <input type="radio" name="gender" value="male" id="male-select">
                            </div>
                            <div class="col-sm-3">
                                <label for="male">Male</label>
                            </div>
                            <div class="col-sm-2">
                                <input type="radio" name="gender" value="female" id="female-select">
                            </div>
                            <div class="col-sm-5">
                                <label for="female">Female</label>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-sm-6">
                <div class="row">
                    <div class="col-sm-4">
                        <label>Region</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-region">
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-2">
            <label>
                <label>Subject</label>
            </label>
        </div>
        <div class="col-sm-10">
            <textarea class="form-control" id="inp-subject"></textarea>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-12 text-right">
            <button class="btn-success" onclick="onBtnSendClick()">Send</button>
        </div>
    </div>
</body>
<script>
    //REGION 3: khai báo các hàm xử lý sự kiện
    function onBtnSendClick(){
        console.log("Bắt đầu gửi dữ liệu!");
        //khai báo biến lưu thông tin cá nhân
        var vPersonObj = {
            fname: "",
            lname: "",
            bday:"",
            gender: null,
            passport:"",
            email:"",
            country:"",
            region:"",
            subject:""
        }
        //b1: đọc dữ liệu
            dataRead(vPersonObj);
        //b2: kiểm tra dữ liệu
        var vCheck = dataValidation(vPersonObj);
        if (vCheck){
        //b3: xử lý dữ liệu
        dataProcessing(vPersonObj);}
    }
    //REGION 4: khai báo các hàm dùng chung
    function dataRead(paramPersonObj){
        //debugger;
        paramPersonObj.fname = document.getElementById("inp-fname").value;
        paramPersonObj.lname = document.getElementById("inp-lname").value;
        paramPersonObj.bday = document.getElementById("inp-bday").value;
        paramPersonObj.gender = getGender(paramPersonObj); //cần định nghĩa hàm này
        paramPersonObj.passport = document.getElementById("inp-passport").value;
        paramPersonObj.email = document.getElementById("inp-email").value;
        paramPersonObj.country = document.getElementById("inp-country").value;
        paramPersonObj.region = document.getElementById("inp-region").value;
        paramPersonObj.subject = document.getElementById("inp-subject").value;
        //return paramPersonObj;
    }

    function getGender(paramPersonObj){
        var vMaleSelect = document.getElementById("male-select");
        var vFemaleSelect = document.getElementById("female-select");
        if (vMaleSelect.checked){
            return "male";
        }
        else if (vFemaleSelect.checked){
            return "female";
        }
        else alert ("Please select gender");
    }
    function dataValidation(paramPersonObj){
        if (paramPersonObj.fname == "" ||
        paramPersonObj.lname == "" ||
        paramPersonObj.bday == "" ||
        paramPersonObj.passport == "" ||
        paramPersonObj.country == "" ||
        paramPersonObj.gender == null){
            alert("Please input firstname, lastname, birthday, gender, passport and country");
            return false;
        }
        else if (validateEmail(paramPersonObj.email) == false){
            return false;
        }
        else return true;
    }

    function dataProcessing(paramPersonObj){
        console.log("First name: " + paramPersonObj.fname);
        console.log("Last name: " + paramPersonObj.lname);
        console.log("Birthday: " + paramPersonObj.bday);
        console.log("Gender: " + paramPersonObj.gender);
        console.log("Passport: " + paramPersonObj.passport);
        console.log("Email: " + paramPersonObj.email);
        console.log("Country: " + paramPersonObj.country);
        console.log("Region: " + paramPersonObj.region);
        console.log("Subject: " + paramPersonObj.subject);
    }

    //hàm kiểm tra email
    function validateEmail(paramEmail){
    if (paramEmail==""){
        return true;
    }
    var vViTriAt = paramEmail.indexOf("@");
    if (vViTriAt == -1){
        alert ("Email should include @");
        return false;
    }
    else if (vViTriAt == 0 || vViTriAt == paramEmail.length - 1){
        alert ("Email should include @ between at least 2 other characters");
        return false;
    }
    return true;  
    }
</script>
</html>